// management of ROM data

#include <stdio.h>
#include "rommgmt.h"

namespace xatremu
{

ROMMgmt::ROMMgmt(){
	ROMSize = 0;
	ROMData = NULL;
};

ROMMgmt::~ROMMgmt(){
	if (ROMSize > 0) {
		delete[] ROMData;
	};
	ROMSize = 0;
};

int ROMMgmt::LoadData(const char* fileName){
	FILE * f;
	f = fopen(fileName, "rb");
	if (f == NULL)
		return 0;
	fseek(f, 0L, SEEK_END);
	ROMSize = (unsigned long int) ftell(f);
	fseek(f, 0L, SEEK_SET);
	if (ROMSize > 0x10000)
		ROMSize = 0x10000;
	ROMData = new unsigned char[ROMSize+3];
	fread(ROMData, 1, ROMSize, f);
	fclose(f);

	return 1;
};

unsigned char * ROMMgmt::GetDataPtr(){
	return ROMData;
};

unsigned long int ROMMgmt::GetDataLen(){
	return ROMSize;
};

}
